@echo off
COLOR 0C
mode con cols=80 lines=25
if exist "%cd%\tmp\CpuMeasureDone.tmp" del /f /q "%cd%\tmp\CpuMeasureDone.tmp"
if exist "%cd%\tmp\CPULoad.log" del /f /q "%cd%\tmp\CPULoad.log"
if exist "%windir%\SysWOW64" (set "X264Ver=x264_x64.exe") else (set "X264Ver=x264_x32.exe")
tasklist>nul
if %errorlevel%==0 (set TaskListAllowed=1) else (set TasklistAllowed=0)
set Mcount=0
set SumCPULoad=0

setlocal enabledelayedexpansion
:MEASURE
FOR /F "tokens=1,2 delims==" %%a IN ('"WMIC CPU GET LoadPercentage /VALUE"') DO ( 
	if /i "%%a"=="LoadPercentage" (
		cls
		REM // ignore first value, because x264 may be not ready yet
		REM if not defined CurrCPULoad (set "CurrCPULoad=%%b" & echo MEASURE:!CurrCPULoad! & PAUSE & goto :MEASURE)
		set "CurrCPULoad=%%b"
		REM // Try to remove line break, that "WMIC CPU GET LoadPercentage" adds to "CurrCPULoad"
		if not defined CurrCPULoad (goto :MEASURE)
		set /a CurrCPULoad=CurrCPULoad*1
		echo. & echo. & echo. & echo. & echo. & echo. & echo. & echo. & echo                              X-QuaSaT CPU-load 1.1 & echo. & echo                              CURRENT CPU-Load: !CurrCPULoad!
		set /a MCount=MCount+1
		set /a SumCPULoad=!SumCPULoad!+!CurrCPULoad!
	)
)
REM // Only for Current Screen Output, not needed for "cpuload.log"
set /a CPULoad=SumCPULoad/MCount
echo                              OVERALL CPU-Load: !CPULoad!

if %TaskListAllowed%==1 (
	for /f %%a in ('tasklist /NH /FI "IMAGENAME eq %x264Ver%"') do (
		set "listsuccess=1"
		if /i not "%%a"=="%x264Ver%" (
		echo                              "%%a" active...
			if not exist "%cd%\tmp\TermCPUMeasure.tmp" (echo.>"%cd%\tmp\TermCPUMeasure.tmp")
		)
		
	)
)
REM /* on WinXP tasklist returns only stderr-value when process isn't found, so for-loop does nothing
REM    and listsuccess isn't set to "1" -> terminate program through creating TermCPUmeasure.tmp
if %TaskListAllowed%==1 (
	if not "%listsuccess%"=="1" (
		 echo.>"%cd%\tmp\TermCPUMeasure.tmp"
	)
)
set "listsuccess=0"
if not exist "%cd%\tmp\TermCPUMeasure.tmp" goto :MEASURE

REM // remove last value, because x264 maybe terminated already
if not %MCount%==1 (
	set /a SumCPULoad=SumCPULoad-CurrCPULoad
	set /a MCount=MCount-1
)
set /a SumCPULoad=SumCPULoad/MCount
echo !SumCPULoad!>"%cd%\tmp\CPULoad.log"
echo.>"%cd%\tmp\CpuMeasureDone.tmp"
endlocal

COLOR 07
EXIT